/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*

blurring functions

*/

#include	"prefs.h"



/* for src/dest of same dimensions */
void	blur_data_4(unsigned char *src, unsigned char *dest, 
	int width, int height, int hamount, int vamount)
		  
{
	int x, y;
	unsigned int i = 0;


	for(y = 0; y < height; y++) {
		for(x = 0; x < width; x++) {

		dest[i] =
		(src[i - (width * vamount)] +
		src[i + (width * vamount)] +
		src[i - hamount] +
		src[i + hamount]) >> 2;	

		i++;
		}
	}

}

void	blur_data_8(unsigned char *src, unsigned char *dest, 
		  int width, int height, int hamount, int vamount)
{
	int x, y;
	unsigned int i = 0;


	for(y = 0; y < height; y++) {
		for(x = 0; x < width; x++) {

		dest[i] =
		(src[i - (width * vamount) - hamount] +
		src[i - (width * vamount)] +
		src[i - (width * vamount) + hamount] +
		src[i + (width * vamount) - hamount] +
		src[i + (width * vamount)] +
		src[i + (width * vamount) + hamount] +
		src[i - hamount] +
		src[i + hamount]) >> 3;	

		i++;
		}
	}
}

void blur_opt(unsigned char *screen, unsigned char *temp1, unsigned long temp2)
{
	blur_data_8(screen, temp1, VWIDTH, VHEIGHT, 1, 1);
}
