/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*

some quick math functions (cos/sin) replacements for use with internal LUT

*/

#include	<stdio.h>
#include	<math.h>
#include	"fastmath.h"


/*
 * uses fixed point, FBITS is fractional part.
 */
int	*costable, *sintable;


int init_math(void)
{
	int	i;

	/* could do a space optimization, technically
	 * cos/sin overlap halfway.
	 */
	costable = (int *)calloc(sizeof(int), 512);
	if( costable == NULL ) {
		return 0;
	}
	sintable = &costable[256];

	
	for(i = 0; i < 256; i++) {
		costable[i] = ((cos((double)2*M_PI*i/256)) * FBITSEXP);
		sintable[i] = ((sin((double)2*M_PI*i/256)) * FBITSEXP);
		// printf("%i : cos: %i\n sin: %i\n", i, costable[i], sintable[i]);
	}

	return 1;
}


/* in degrees */
inline int fastcos(int d)
{
	return(costable[d % 256]);
}


/* in degrees */
inline int fastsin(int d)
{
	return(sintable[d % 256]);
}
