/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include	"fastmath.h"
#include	"../prefs.h"

#define twidth   64
#define	theight   64


void rotate(unsigned char *txtr, int phase, int zoom,/* int *zmap, */
             unsigned char *dst, unsigned int dwidth, unsigned int dheight)
{

	/* texture coords */
	static unsigned char    tx;
	static unsigned char    ty;

	/* destination coords */
	static unsigned int	i;
	static int    	dx, dfx;
	static int    	dy, dfy;
	static int	cosine, sine;
	static int	ycos, ysin;

	/* if zmap is null we just use zoom for all pixels,
	 * if it is non-null we zoom each pixel by the zmap value at that position.
	 */

	cosine = fastcos(phase);
	sine = fastsin(phase);



	for(i = 0, dy = -VHEIGHT / 2; dy < VHEIGHT / 2; dy++) {
		dfy = (dy << FBITS);
		ycos = (dfy * cosine) >> FBITS;
		ysin = (dfy * sine) >> FBITS;

		for(dx = -VWIDTH / 2; dx < VWIDTH / 2; dx++, i++) {
			dfx = (dx << FBITS);


			/*zoom = zmap[i];*/
			tx = (zoom * ((((dfx * sine) >> FBITS) - 
			     (ycos))) >> FBITS) >> FBITS;

			ty = (zoom * (((ysin) + 
			     ((dfx * cosine) >> FBITS))) >> FBITS) >> FBITS;


		/* shrink coords to 64, then multiply y by 64 */
			dst[i] = txtr[((ty >> 2) << 6) + (tx >> 2)];
		}
	}
}
