/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*
variable wave distortion
*/


#include	<math.h>
#include	"fastmath.h"


void wave(void * src, void * dest, double amp, double phase, double freq, int width, int height)
{
	unsigned char *tdest, *tsrc;
	int	twidth, theight;
	int	x, y;
	int	xoff, yoff;
	int	cur_y;
	double  ix = 0, iy = 0;

	tsrc = src;
	tdest = dest;



	for(y = 0; y < height; y++) {
		yoff = y + (amp * cos(phase + iy));	
		cur_y = y * width;

		for(x = 0; x < width; x++) {
			xoff = x + (amp * cos(phase + ix));	

			if( xoff < width &&
			    xoff > 0 &&
			    yoff < height &&
			    yoff > 0 ) {

				tdest[(cur_y + x)] = 
				tsrc[((yoff) * width) + xoff];

			}

		ix += freq;

		}

	iy += freq;

	}
}
