#	Loop
#
#       Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com
#
#       Loop is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 2 of the License, or
#       (at your option) any later version.
#
#       Loop is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#
#low level modex screen buffer blitting routine.
#not very flexible, but fairly quick.
#

#ifdef	MODEX

.data

current_offset:
.long 	76800

screen_size:
.long	76800

.text			


bitblit:		.global	bitblit
pushal

	call	vga_lockvc	#lock console while updating
	
	movl	$0x3c4, %edx
	movb	$2, %al
	outb	%al, %dx
	incl	%edx	#set plane port
	

	movl	graph_mem, %edi
	movl	current_offset, %ebx
	shrl	$2, %ebx	#divide offset by 4 (planar)
	addl	%ebx, %edi	#adjust to current offset (page for flipping)
	subl	$4, %edi

	movl	36(%esp), %esi	#get source
	addl	$76800, %esi	#put source to end

	movl	$16, %ebp

	xorl	%eax, %eax	


####################################################
#plane 0
####################################################
	movl	$4800, %ecx	#quantity


	incb	%al
	outb	%al, %dx	#set plane

plane_0_loop:
	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx	
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl
	
	subl	%ebp, %esi

		movl	%ebx, (%edi, %ecx, 4)
	
	decl	%ecx



	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl
	
	subl	%ebp, %esi

		movl	%ebx, (%edi, %ecx, 4)
	
	decl	%ecx
	jnz	plane_0_loop



###########################################
#plane 1
###########################################

	movl	36(%esp), %esi
	addl	$76800, %esi
	incl	%esi
	movl	$4800, %ecx	#quantity
	
	incb	%al
	outb	%al, %dx	#set plane

plane_1_loop:
	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)

	decl	%ecx



	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)

	decl	%ecx

	jnz	plane_1_loop



###############################################
#plane 2
###############################################

	movl	36(%esp), %esi
	addl	$76800, %esi
	addl	$2,%esi
	movl	$4800, %ecx	#quantity

	addb	$2, %al	
	outb	%al, %dx	#set plane

plane_2_loop:
	
	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)

	decl	%ecx



	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)

	decl	%ecx

	jnz	plane_2_loop



###################################################
#plane 3
###################################################

	movl	36(%esp), %esi
	addl	$76800, %esi
	addl	$3,%esi
	movl	$4800, %ecx	#quantity

	addb	$4, %al	
	outb	%al, %dx	#set plane

plane_3_loop:
	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)
	
	decl	%ecx



	movb	-4(%esi), %bh
	movb	-8(%esi), %bl
		shll	$16, %ebx
	movb	-12(%esi), %bh
	movb	-16(%esi), %bl

	subl	%ebp, %esi

		movl	%ebx, (%edi,%ecx,4)
	
	decl	%ecx

	jnz	plane_3_loop



############################################################
#page flipping
############################################################
	
	call	vga_waitretrace
	call	vga_waitretrace
	call	vga_waitretrace
	movl	current_offset, %ebx	

	cmpl	$0, %ebx
	jne	next_page
	movl	screen_size, %eax
	movl	%eax,  current_offset
	jmp	flip

	next_page:
	movl	$0, current_offset

	flip:
	pushl	%ebx
	call	vga_setdisplaystart
	addl	$4, %esp

	call	vga_unlockvc		#unlock the console when finished
popal
ret

#endif
