/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include	<stdio.h>
#include	<stdlib.h>
#include	<pthread.h>
#include	<sys/time.h>
#include	<sys/resource.h>

#ifdef	SDLHACK
#	include		<SDL/SDL.h>
#else
#	include		<vga.h>
#endif

#include	"fastmath.h"
#include	"./prefs.h"
#include	"io/synch.h"
#include	"io/music.h"

#include	"scenes/scenes.h"

#define		demo_version	"16.845"
#define		ITFILE		"data/loop.it"



#ifdef	SDLHACK
	extern SDL_Surface	*SDLscreen;
#endif
	int			premature = 0;
	int			effekt = 0;
	int			noexit = 1;


void *	mikmodthread(void *blah)
{
	playsong(ITFILE);
	pthread_exit(0);
}


void *	loopthread(void *blah)
{
	unsigned char 		*temp1_buffer;
	unsigned char 		*temp2_buffer;
	unsigned char 		*screen_buffer;


	/* allocate screen buffers */
	printf("Allocating memory...\n");

	screen_buffer = calloc(1, VWIDTH * (VHEIGHT + 2));
	if(screen_buffer == NULL) {
		printf("Error allocating screen_buffer.\n");
		return 0;
	}

	temp1_buffer = calloc(1, VWIDTH * (VHEIGHT + 2));
	if(temp1_buffer == NULL) {
		printf("Error allocating temp1_buffer.\n");
		return 0;
	}

	temp2_buffer = calloc(1, VWIDTH * (VHEIGHT + 2));
	if(temp2_buffer == NULL) {
		printf("Error allocating temp2_buffer.\n");
		return 0;
	}

	/* padding on the buffers of 1 line to allow dirty (faster) blurring
	   and such effects. 3 is actually more than needed, but I got lazy.
	*/
	screen_buffer += VWIDTH;
	temp1_buffer += VWIDTH;
	temp2_buffer += VWIDTH;

	/* initialize sin/cos LUT */
	init_math();


	init_gfx();

	srand(time(NULL));

#ifdef SDLHACK
	SDL_WM_SetCaption(". L O O P .", "loop-sdl");
#endif

	printf("And now, my friends, the action begins.  Hopefully.\n");
	intro(screen_buffer, temp1_buffer, temp2_buffer);
	psychadelic(screen_buffer, temp1_buffer, temp2_buffer);
	jupiter(screen_buffer, temp1_buffer, temp2_buffer);
	bump(screen_buffer, temp1_buffer, temp2_buffer);
	rotozoom(screen_buffer, temp1_buffer, temp2_buffer);
	fuse(screen_buffer, temp1_buffer, temp2_buffer);
	rain(screen_buffer, temp1_buffer, temp2_buffer);
	credits(screen_buffer, NULL, NULL);

	close_gfx();

	printf("\nCleaning up.");
	free(screen_buffer - VWIDTH);
	printf(".");
	free(temp1_buffer - VWIDTH);
	printf(".");
	free(temp2_buffer - VWIDTH);
	printf(".\n");

	pthread_exit(0);
}


int	main(void)
{
	pthread_t       	mikmod_thread;
	pthread_t		loop_thread;
#ifdef	SDLHACK
	unsigned int		video_flags;
#endif


	printf("Loop version %s\n", demo_version);
	printf("Loading...\n");

        pthread_create( &mikmod_thread, NULL, mikmodthread, NULL);
        pthread_create( &loop_thread, NULL, loopthread, NULL);


	printf("Waiting for libmikmod thread to exit...\n");
	pthread_join(mikmod_thread, NULL);
	printf("Waiting for loop thread to exit...\n");
	pthread_join(loop_thread, NULL);

	printf("\n-*- www.gnugeneration.com/software/loop.html -*-\n"); /* PLUG! */
	printf("\nYeah, Whatevah.\n"); /* sifl & olly 'whatever' */

	printf("\n . L O O P .  1st place @ Spring Break 1999 \n");


	return 1;
}
