
/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*

fuse still image

*/

#include	<stdio.h>
#include	"gfx.h"
#include	"sprite.h"
#include	"prefs.h"

extern int effekt;
extern int noexit;

void fuse(unsigned char *screen, unsigned char *temp1, unsigned char *temp2)
{
	struct PALETTE	*pal, *active_pal;
	struct SPRITE	*sprite; 
	unsigned char	*blankcolors;
	int		j, fadeleft;

	noexit = 1;


	active_pal = get_palette();
	sprite = load_sprite("data/fused.img");
	pal = load_palette("data/fused.pal");
	blankcolors = (unsigned char *)calloc(1, 256 * 3);

	fadeleft = 1;
	while(fadeleft) {
		fadeleft = fade_pal(active_pal->data, blankcolors, 256, 20);
		set_palette(active_pal);
		usleep(1);
	}

	memset(screen, 0, VWIDTH * VHEIGHT);

	draw_sprite_center(sprite, screen, VWIDTH, VHEIGHT);
	unload_sprite(sprite);

	draw_screen(screen);

	fadeleft = 1;
	while(fadeleft) {
		fadeleft = fade_pal(active_pal->data, pal->data, 256, 20);
		set_palette(active_pal);
		if(!fadeleft)
			unload_palette(pal);
		usleep(1);
	}


	while(noexit) {
		usleep(10);
	}

	fadeleft = 1;
	while(fadeleft) {
		fadeleft = fade_pal(active_pal->data, blankcolors, 256, 10);
		set_palette(active_pal);
		usleep(1);
	}


	free(blankcolors);
	unload_palette(active_pal);
}
