/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*

code for introduction of loop

*/

#include	<stdio.h>
#include	"sprite.h"
#include	"../prefs.h"
#include	"gfx.h"
#include	"fastmath.h"
#include	"bumpmap.h"

extern int effekt;
extern int noexit;

void intro(unsigned char *screen, unsigned char *temp1, unsigned char *temp2)
{
	struct PALETTE 	*pal, *active_pal;
	struct SPRITE 	*sprites[3]; /* logo/presents/loop */
	unsigned char 	*swap, *blankcolors;
	int		fadeleft = 1, i = 0, l = 0;
	char 		*wait[4];
	int		xres, yres, sy, sx, phase = 0, p;

	/* our nifty little text thingy to show we are alive */
	wait[0] = "-";
	wait[1] = "/";
	wait[2] = "|";
	wait[3] = "\\";

	sprites[0] = load_sprite("data/csr.img");
	sprites[1] = load_sprite("data/presents.img");
	sprites[2] = load_sprite("data/loop.img");
	pal = load_palette("data/spiralpal.pal");

	blankcolors = (unsigned char *)calloc(1, 256 * 3);
	active_pal = new_palette_struct();	
	active_pal->data = blankcolors;
	active_pal->quantity = 256;
	active_pal->type = PCVGA8BIT;

	/* set blank pallete */
	set_palette(active_pal);

	puts("Waiting for libmikmod...");
	while(noexit) {
		i++;
		printf("\r%s", wait[i % 4]);
		fflush(stdout);
		usleep(1);
	}

	i = 0;
	noexit = 1;

	while( i < 3 ) {
		while(noexit) {
#if 0
			phase++;

			for(p = 0, sy = 0; sy < VHEIGHT; sy++) {
				yres = 	(((fastsin(phase) * (20 << FBITS)) >> FBITS) * fastcos(sy) >> FBITS) +
					((30 << FBITS) * fastcos((sy + phase) * 4) >> FBITS) +
					((50 << FBITS) * fastcos((sy + phase) / 2) >> FBITS);
				for(sx = 0; sx < VWIDTH; sx++, p++) {

					xres = 	(((fastcos(phase) * (50 << FBITS) >> FBITS)) * fastcos(sx ) >> FBITS) +
						((40 << FBITS) * fastcos((sx + phase) * 3) >> FBITS) +
						((60 << FBITS) * fastcos((sx + phase) / 4) >> FBITS);

					screen[p] = ((xres + yres) >> FBITS);
				}
			}
#endif




			draw_sprite_trans_center(sprites[i], screen, VWIDTH, VHEIGHT);

			blur_opt(screen, temp1, VWIDTH * VHEIGHT);


			swap = screen;
			screen = temp1;
			temp1 = swap;

			draw_screen(screen);
		
			if(fadeleft) {
				fadeleft = fade_pal(active_pal->data, pal->data,
						    pal->quantity, 10);
				set_palette(active_pal);
				if(!fadeleft) {
					unload_palette(pal);
					unload_palette(active_pal);
				}
			}

		}

		unload_sprite(sprites[i]);
		i++;
		noexit = 1;
	}

	return;
}
