/*
	Loop

        Copyright (C) 1998-1999 Vito Caputo - swivel@gnugeneration.com

        Loop is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        Loop is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*

roto-stretchy-zoomer scene

*/

#include	<stdio.h>
#include	"rotate.h"
#include	"fastmath.h"
#include	"sprite.h"
#include	"gfx.h"
#include	"../prefs.h"




extern int effekt;
extern int noexit;

void rotozoom(unsigned char *screen, unsigned char *temp1, unsigned char *temp2)
{
	unsigned char 	*blankcolors;
	struct SPRITE 	*image;
	struct PALETTE 	*pal, *active_pal;
	unsigned char 	*buffer;
	int 		i, fadeleft = 1;

	int		R = 0;
	int  		prate = 2;
	int		Z;
	int		zrate = 2;
	int		size = (10 * FBITSEXP);
	int		xres, yres, sy, sx, phase = 0, p, zmap[VWIDTH * VHEIGHT];


	active_pal = get_palette();

	image = load_sprite("data/penguin.img");
	pal = load_palette("data/penguin.pal");
	blankcolors = (unsigned char *)calloc(1, 256 * 3);

	buffer = image->data;

	while(fadeleft) {
		fadeleft = fade_pal(active_pal->data, blankcolors, 256, 10);
		set_palette(active_pal);
		usleep(1);
	}
	
	fadeleft = 1;
	noexit = 1;
	while(noexit) {


		R += prate; 


		Z = ( (13 << FBITS) + ((fastsin(R) * size) >> FBITS));

		rotate(buffer, R, Z, screen, VWIDTH, VHEIGHT);

		draw_screen(screen);

		if(effekt) {
			effekt = 0;

			if(prate < 0) {
				prate = 2;
			} else {
				prate = -2;
			}
		}

		if(fadeleft) {
			fadeleft=fade_pal(active_pal->data, pal->data, pal->quantity, 10);
			set_palette(active_pal);
			if(!fadeleft)
				unload_palette(pal);
		}

	}

	free(blankcolors);
	unload_sprite(image);

	return;
}
